<template>
  <div id="LoadingMessenger">
    <transition-group id="list" name="list" tag="p">
      <div class="request" v-for="msg in messages" :key="msg.id">
        <div class="loader" />
        <pre class="text">{{ msg.text }}</pre>
      </div>
    </transition-group>
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */
import { Component, Vue } from "vue-property-decorator";
import { LoadingMessage } from "@/store/loadingMessages";
import store from "@/store";

@Component
export default class LoadingMessenger extends Vue {
  get messages(): LoadingMessage[] {
    return store.state.loadingMessages.messages;
  }
}
</script>

<style scoped>
#LoadingMessenger {
  position: fixed;
  bottom: 0;
  right: 0;
  z-index: 20;

  overflow: hidden;
}
#list {
  margin-bottom: 0px;
  display: flex;
  flex-direction: column-reverse;
  align-items: flex-end;
}

.request {
  display: flex;
  align-items: center;

  margin: 0 20px 10px 0px;
  padding: 2px 10px 2px 10px;
  color: #fff;
  background-color: var(--blue);
  border-radius: 150px;
  overflow: hidden;
}

.text {
  padding-left: 10px;
  margin: 0;
}

.loader {
  border: 2px solid #f3f3f3; /* Light grey */
  border-top:2px solid #3498db; /* Blue */
  border-right:2px solid #3498db; /* Blue */
  border-radius: 100%;
  width: 15px;
  height: 15px;
  animation: spin 3s linear infinite;
}

@keyframes spin {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}

.list-enter-active,
.list-leave-active {
  transition: opacity 1s ease-in, transform 1s;
}
.list-enter, .list-leave-to {
  opacity: 0;
  transform: translateY(30px);
}
</style>
